## hol88 2.02.19940316dfsg

=== Makefile ===
#=====================================================================
#
# 		  MAKEFILE FOR THE HOL SYSTEM
#
# =====================================================================

# =====================================================================
# INSTRUCTIONS:
#
# (1) Site dependent macros:
#
#     There are two flags and four site-dependent pathnames used in
#     this makefile which you may have to change to rebuild hol at
#     your site.
#
#     They are given by the six macros:
#
#           LispType, Obj, Lisp, Liszt, LisztComm and HOLdir
#
#     To use this makefile at your site, you may have to edit these
#     macros to reflect local lisp setups and local pathnames. See the
#     note below under MACROS for a description of these macros.
#     
# (2) To build hol.
#
#     To build hol, just type: "make hol".  This will build the hol
#     system, and create an executable version of hol in the form
#     of a file called "hol" in this directory.
#
#     Typing "make hol" will recompile any source code that needs
#     to be recompiled.  So if you make changes to any of the system's
#     source code files, just type "make hol" to recompile and 
#     rebuild the system.  Only the code that needs to be recompiled
#     to reflect the changes will be compiled.
#
#     Note: typing "make hol" will NOT, in general, rebuild any of the 
#     built-in theories.  In particular, a theory <file>.th will
#     be recreated only if:
#
#	     a) the corresponding ml source: mk_<file>.ml has 
#	        been changed, or
#
#	     b) a parent of the theory <file>.th has been changed.
#
#     This means that  if the executable code used to create a
#     theory changes (e.g. hol-lcf), the theory will not be rebuilt.
#     This is done to avoid unnecessary and time-consuming rebuilding 
#     of the built-in theories.
#
#     To force a theory to be rebuilt, remove the theory file.  
#     Or "touch" the corresponding file: mk_<file>.ml.  This is worth
#     doing, to check if the built-in theories can be rebuilt.
#
# (3) To completely rebuild hol from scratch.
#
#     To do a total rebuild of the system, including theory files, 
#     type "make clobber" before rebuilding hol.  This will remove all
#     object code and all theory files.  It is worth trying this at some
#     point to make sure that it's possible to do a total rebuild.
# =====================================================================

# =====================================================================
# SUMMARY OF MAIN ENTRIES:
#
# make all	      : builds hol and all libraries
#
# make hol	      : builds hol, compiling sources whenever necessary
#
# make clean          : removes object code from hol system and lisp
#
# make clobber	      : removes all object code and theories (incl. libraries)
#
# make library	      : rebuilds the library
#
# make clean-library  : removes object code and theories in the library
# =====================================================================

# =====================================================================
# MACROS:
#
# LispType     = the type of the lisp system used to build HOL. 
#                Possibilities are cl (for Common Lisp) or franz 
#                (for Franz Lisp).
#
# Obj          = the default filename extension for compiled lisp files.
#                for Franz Lisp this is o; for Common Lisp this depends on
#                the implementation. Some implementations and values are:
#
#                   Lucid CL     lbin
#                   KCL, AKCL    o
#                   Allegro CL   fasl
#
# Lisp         = the lisp system used to build HOL.  This can be 
# 		 an absolute pathname, a relative pathname, or simply
#		 the name of the appropriate shell command (e.g. "lisp")
#                provided this can be found by following the builder's 
#                unix search path.
# 
# Liszt        = the franz lisp complier used to build HOL.  This can be 
#	 	 an absolute pathname, a relative pathname, or simply
#		 the name of the appropriate shell command (e.g. "liszt")
#                provided this can be found by following the builder's 
#                unix search path. This macro is relevant only for
#	         building a Franz Lisp version of HOL.
#
# LisztComm    = the command issued (internally) by HOL to call the 
#		 lisp compiler when compiling ML.  This can be just 
#		 "liszt", if liszt will be found by following the HOL 
#		 user's search path. An absolute pathname can also be 
#		 nused for LisztComm. This macro is relevant onlt
#                for building a Franz Lisp version of HOL.
#
# Allegro      = Option for case-sensitivity in any version of Allegro
#                common lisp.
#
# AllegroV4.0  =  Allegro 4.0 specials
#
# AllegroV4.1  = Allegro 4.1 specials
#
#
# AllegroStuff = Combinations of options for any given version of
#                Allegro common lisp.
#
# HOLdir       = the absolute pathname of the top-level HOL directory
#
# Theory       = the directory where built-in .th files will be put.
#
# Library      = the absolute pathname of the library directory
#
# Help 	       = the absolute pathnames to the HOL help directories
#
# Hol          = the HOL system to be used for building libraries
#               (normally hol)
#
# LispDir      = the directory where the Lisp sources are
#               (used for Library/eval and Library/prog_logic88)
#
# Version      = the version number of HOL.  This is incremented by 
#		 0.01 whenever a change is made, and incremented by 
#		 1.0 for a major new release.
# ExeName      = the executable file name to be built
# =====================================================================

# *********************************************************************
# To install HOL, edit the following definitions of:
#     LispType, Obj, Lisp, Liszt, LisztComm, and HOLdir 
# *********************************************************************

SHELL=/bin/sh

LispType=cl
Obj=o
Lisp=akcl
Liszt=
LisztComm=
Allegro=(set-case-mode :case-insensitive-upper)
AllegroV4.0= $(Allegro) (setq *cltl1-in-package-compatibility-p* t) (setq comp:*cltl1-compile-file-toplevel-compatibility-p* t)

AllegroV4.1= $(AllegroV4.0) (setq *enable-package-locked-errors* nil)
AllegroStuff= (progn () $(AllegroV4.1))

HOLdir=/usr/local/hol
Theory=$(HOLdir)/theories
Library=$(HOLdir)/Library
Help=$(HOLdir)/help/ENTRIES/

Hol=hol
LispDir=${HOLdir}/lisp

ExeName = hol
Version = 2.02 (SUN4/AKCL)

# =====================================================================
# Default (from Phil Windley)
# =====================================================================

default:
	@echo "Type \"make all\" to make hol and the Library,
	@echo "\"make hol\" to just make hol, or \"make clean\"
	@echo "to delete object files."

# =====================================================================
# Cleaning functions
# =====================================================================

clean:
	/bin/rm -f ml/*_ml.o ml/*_ml.l ml/site.ml lisp/*.$(Obj)
	/bin/rm -f hol-lcf basic-hol hol
	$(MAKE) clean-library
	@echo "=======> all hol and lisp object code deleted"

clobber:
	/bin/rm -f ml/*_ml.o ml/*_ml.l ml/site.ml lisp/*.$(Obj)
	/bin/rm -f ${Theory}/*.th hol-lcf basic-hol hol
	$(MAKE) clobber-library
	@echo "=======> all object code and theory files deleted"

clean-library:
	(cd ${Library}; $(MAKE) Obj=${Obj} clean; cd ..)

clobber-library:
	(cd ${Library}; $(MAKE) Obj=${Obj} clobber; cd ..)


# =====================================================================
# MAKEFILE ENTRIES FOR HOL
# =====================================================================

# ---------------------------------------------------------------------
# Macros: 
#
#   HolMl = the ml object code that hol depends on
# ---------------------------------------------------------------------

HolMl=ml/load_thms.ml ml/numconv_ml.o ml/tydefs_ml.o ml/ind_ml.o\
      ml/prim_rec_ml.o ml/tyfns_ml.o ml/num_ml.o ml/list_ml.o\
      ml/lib_loader_ml.o

# ---------------------------------------------------------------------
# main entry for hol
# ---------------------------------------------------------------------

hol: basic-hol ${Theory}/HOL.th $(HolMl) lisp/banner.$(Obj) lisp/akcl.l
	echo 'set_search_path[``; `${Theory}/`];;'\
	     'load_theory `HOL`;;'\
	     'loadf `ml/load_thms`;;'\
	     'loadf `ml/lib_loader`;;'\
	     'loadf `ml/numconv`;;'\
	     'loadf `ml/tydefs`;;'\
	     'loadf `ml/ind`;;'\
	     'loadf `ml/prim_rec`;;'\
	     'loadf `ml/tyfns`;;'\
	     'loadf `ml/num`;;'\
	     'loadf `ml/list`;;'\
	     'map delete_cache [`arithmetic`;`sum`;`list`];;'\
	     'map delete_cache [`tree`;`ltree`;`prim_rec`];;'\
	     'lisp `(load "lisp/banner")`;;'\
	     'lisp `(setq %system-name "HOL")`;;'\
	     'lisp `(setq %hol-dir "$(HOLdir)")`;;'\
	     'lisp `(setq %lib-dir "$(Library)")`;;'\
	     'lisp `(setq %liszt "$(LisztComm)")`;;'\
	     'lisp `(setq %version "$(Version)")`;;'\
	     'set_flag(`abort_when_fail`,false);;'\
	     'set_search_path[``; `~/`; `${Theory}/`];;'\
	     'set_help_search_path (words `$(Help)`);;'\
	     'set_library_search_path [`${Library}/`];;'\
	     'lisp `(load "lisp/akcl.l")`;;'\
	     'lisp `(setup)`;;'\
	     'save `${ExeName}`;;'\
	     'set_thm_count 0;;'\
	     'quit();;'\
	     | basic-hol
	make permissions
	@echo "=======> hol88 version $(Version) made"

library: $(ExeName) 
	date
	(cd ${Library}; $(MAKE) LispType=${LispType}\
                             Obj=${Obj}\
                             Lisp=${Lisp}\
                             Liszt=${Liszt}\
                             LispDir=${LispDir}\
                             Hol=${HOLdir}/${ExeName} library; cd ..)
	date

all:
	(date; $(MAKE) hol; date; $(MAKE) library; date)
	make permissions
	@echo "=======> hol Version $(Version) and libraries made"


# ---------------------------------------------------------------------
# Entry for changing permissions.
#
# Macros:
#
#  directories:          Dperm  =  drwxrwxr-x  = 775
#  text files:           Tperm  =  -rw-rw-r--  = 664
#  executable files:     Eperm  =  -rwxrwxr-x  = 775
#
#                        Exec = those files to be "executable"
#
# ---------------------------------------------------------------------

Dperm=775
Tperm=664
Eperm=775

Exec=hol hol-lcf basic-hol Manual/LaTeX/makeindex\
     Manual/LaTeX/makeindex.bin/*/makeindex\
     Manual/Reference/bin/mktex Manual/Reference/bin/typecheck

permissions:
	find . \( -type d -user $(USER) -exec chmod $(Dperm) {} \; \) -o\
	       \( -type f -user $(USER) -exec chmod $(Tperm) {} \; \)
	@for f in $(Exec) ; do\
	  ( if [ -f $$f ]; then\
	    find $$f \( -user $(USER) \) -exec chmod $(Eperm) {} \; ;fi) ; \
	done


# ---------------------------------------------------------------------
# makefile entries for hol system ml code
# ---------------------------------------------------------------------

ml/numconv_ml.o: basic-hol ${Theory}/num.th ml/numconv.ml 
	echo 'load_theory `num`;;'\
	     'compilet `ml/numconv`;;'\
	     'quit();;'\
	| basic-hol

ml/lib_loader_ml.o: basic-hol ml/lib_loader.ml 
	echo 'compilet `ml/lib_loader`;;'\
	     'quit();;'\
	| basic-hol

ml/tydefs_ml.o: basic-hol ${Theory}/HOL.th ml/load_thms.ml ml/tydefs.ml 
	echo 'set_search_path[``; `${Theory}/`];;'\
	     'load_theory `HOL`;;'\
	     'compilet `ml/tydefs`;;'\
	     'quit();;'\
	| basic-hol

ml/ind_ml.o: basic-hol ml/ind.ml 
	echo 'compilet `ml/ind`;;'\
	     'quit();;'\
	| basic-hol

ml/prim_rec_ml.o: basic-hol ml/prim_rec.ml 
	echo 'compilet `ml/prim_rec`;;'\
	     'quit();;'\
	| basic-hol

ml/tyfns_ml.o: basic-hol ${Theory}/HOL.th ml/prim_rec_ml.o ml/load_thms.ml ml/tyfns.ml
	echo 'set_search_path[``; `${Theory}/`];;'\
	     'load_theory `HOL`;;'\
	     'compilet `ml/tyfns`;;'\
	     'quit();;'\
	| basic-hol

ml/num_ml.o: basic-hol ${Theory}/HOL.th ml/ind_ml.o ml/prim_rec_ml.o\
	     ml/num.ml ml/numconv_ml.o

=== Library/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL SYSTEM LIBRARY
#
# =====================================================================

# =====================================================================
# SUMMARY OF MAIN ENTRIES:
#
# make library	   : rebuilds the library, compiling sources whenever 
#
# make clean	   : removes all object code
#
# make clobber	   : removes all object code, and theories
#
# =====================================================================

# =====================================================================
# MACROS:
#
# Libraries = a list of all libraries to be made
#
# Hol	    = the pathname of the version of hol that will be used to 
#	      rebuild the library.
#
# LispType  = the type of the lisp system, cl or franz
#
# Obj       = the default filename extension for compiled lisp files.
#
# Lisp      = the pathname of the common lisp system (not used for franz)
# 
# Liszt     = the pathname of the franz lisp compiler (not used for cl)
#
# LispDir   = the directory where the Lisp sources are
# =====================================================================

Libraries = unwind taut sets reduce arith pred_sets string finite_sets\
	    res_quan wellorder abs_theory reals window pair word\
	    record_proof parser prettyp trs latex-hol more_arithmetic\
	    numeral ind_defs

# NB: UNITY, auxiliary, bags, convert, eval, fixpoints, group, int_mod,
#     integer, prog_logic88, and quotient moved to contrib, 1 Mar. 94 by RJB
# NB: more_lists has been moved to contrib from the library 9 Feb. 94 by WW
# NB: card, well_order, zet, csp temporarily removed from the library

Hol=../hol
LispType=cl
Obj=fasl
Lisp=cl
Liszt=
LispDir=/usr/local/hol/lisp

clean:
	for lib in ${Libraries} ; \
	    do (cd $$lib; $(MAKE) Obj=${Obj} clean; cd ..) ; \
	done
	@echo "===> all library object code deleted"

clobber:
	for lib in ${Libraries} ; \
	    do (cd $$lib; $(MAKE) Obj=${Obj} clobber; cd ..) ; \
	done
	@echo "===> all library object code and theory files deleted"

library:
	for lib in ${Libraries} ; \
	    do (cd $$lib; $(MAKE)  LispType=${LispType}\
                                   Obj=${Obj}\
                                   Lisp=${Lisp}\
                                   Liszt=${Liszt}\
                                   LispDir=${LispDir}\
                                   Hol=${Hol} all; cd ..) ; \
	done
	@echo "=======> library rebuilt"

=== Manual/Makefile ===
# =====================================================================
# Makefile for the hol manual
# =====================================================================

default:
	@echo "INSTRUCTIONS:"
	@echo ""
	@echo "1) type \"make reference\" to make only REFERENCE, or"
	@echo ""
	@echo "2) type \"make description\" to make only DESCRIPTION, or"
	@echo ""
	@echo "3) type \"make tutorial\" to make only TUTORIAL, or"
	@echo ""
	@echo "4) type \"make libraries\" to make only LIBRARIES, or"
	@echo ""
	@echo "5) type \"make covers\" to make fancy cover pages, or"
	@echo ""
	@echo "6) type \"make all\" to create the entire manual."

tutorial:
	(cd Tutorial; make all; cd ..)
	@echo "====> TUTORIAL made"

description:
	(cd Description; make all; cd ..)
	@echo "====> DESCRIPTION made"

reference:
	(cd Reference; make all; cd ..)
	@echo "====> REFERENCE made"

libraries:
	(cd Libraries; make all; cd ..)
	@echo "====> LIBRARIES made"

covers:
	(cd Covers; make all; cd ..)
	@echo "====> Fancy covers made"

all:
	make tutorial;make description; make reference;make libraries;make covers
	@echo "=======> MANUAL made"

=== Library/abs_theory/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR abs_theory Library.
#
# =====================================================================

# =====================================================================
#
# MAIN ENTRIES:
#
# make all	    : create theories and compile code
#
# make clean	    : remove theories and compiled code
#	
# =====================================================================

# =====================================================================
# MACROS:
#
# Name      : name of library
#
# Hol	    : the pathname of the version of hol used
#
# Root	    : root directory for the directory holding this file
#
# Home      : directory (relative to Root) that contains this file
#
# Library   : root directory for library
#
# ML        : list of ML sources
#
# =====================================================================

Name=abs_theory

Hol=hol

Root=../..

Home=${Root}/Library/abs_theory

Lib=${Root}/Library

default:
	@echo "===> ${Name}. Type \"make example,\" \"make abs_theory_ml.o,\" or \"make clean\""

all:	example abs_theory_ml.o

clean:
	-/bin/rm -f *_ml.o 
	@echo "===> ${Name}. All object code deleted"

clobber:
	-/bin/rm -f *_ml.o *.th print
	@echo "===> ${Name}: All object code and theory files deleted"

# =====================================================================
# Add new suffixes for ML and theory files
# =====================================================================
.SUFFIXES: .ml .th 

# =====================================================================
# Default action for creating a .th file from a .ml file.
# =====================================================================
.ml.th: 
	@ echo Making ${Home}/$*.th...;\
	  echo 'set_flag(`abort_when_fail`,true);;'\
             'set_flag(`prompt`,false);;'\
             'set_flag(`sticky`,true);;'\
             'set_flag(`timing`,true);;'\
             'set_search_path (search_path() @ '\
             '   [`${Root}/ml/`;'\
             '   ]);;'\
	     'loadt `${Home}/$*.ml`;;'\
	     'quit();;' | ${Hol} || ${RM} $*.th


# =====================================================================
# List of ML source texts 
# =====================================================================
ML= monoid_def.ml group_def.ml example.ml

example: example.th
	@echo "===> ${Name} rebuilt on `date`"


abs_theory_ml.o: abs_theory.ml
	@ echo Making abs_theory.ml;\
	  echo 'set_flag(`abort_when_fail`,true);;'\
             'set_flag(`prompt`,false);;'\
             'set_flag(`sticky`,true);;'\
             'set_flag(`timing`,true);;'\
             'set_search_path (search_path() @ '\
             '   [`${Root}/ml/`;'\
             '   ]);;'\
	     'compilet `abs_theory`;;'\
	     'quit();;' | ${Hol} || ${RM} $*.th



# =====================================================================    
# Print recently changed files
# =====================================================================
print:	${ML}
	-@for f in $?; \
	  do 2up $$f | lpr -x; \
	     echo "Printing $$f" ;\
	  done
	 @touch print 


# =====================================================================    
# information below this line is generated automatically by depgen
# =====================================================================    
example.th: example.ml group_def.th
group_def.th: group_def.ml monoid_def.th
monoid_def.th: monoid_def.ml

=== Library/finite_sets/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: finite_sets
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o
	@echo "===> library finite_sets: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l *.th 
	@echo "===> library finite_sets: object code and theory files deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

finite_sets.th: mk_finite_sets.ml 
	rm -f finite_sets.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `mk_finite_sets`;;' | ${Hol} 

set_ind_ml.o: finite_sets.th set_ind.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_theory `finite_sets`;;'\
	     'compilet `set_ind`;;'\
	     'quit();;' | ${Hol}

fset_conv_ml.o: finite_sets.th fset_conv.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_theory `finite_sets`;;'\
	     'compilet `fset_conv`;;'\
	     'quit();;' | ${Hol}


# =====================================================================
# Main entry
# =====================================================================

all: finite_sets.th set_ind_ml.o fset_conv_ml.o 
	@echo "===> library finite_sets rebuilt"

=== Library/latex-hol/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: latex-hol
#
# =====================================================================

# =====================================================================
#
# MAIN ENTRIES:
#
# make all	    : compile code
#
# make clean	    : remove compiled code
#	
# make clobber	    : remove pp code and compiled code
# =====================================================================

# =====================================================================
# MACROS:
#
# Hol	    : the pathname of the version of hol used
# =====================================================================

#Hol=../../hol
Hol=/usr/groups/hol/HOL21/bin/hol

clean:
	rm -f *.o
	@echo "===> library latex-hol: all object code deleted"
clobber:
	rm -f latex_*_pp.ml  *.o
	@echo "===> library latex-hol: all object code and _pp.ml file deleted"


latex_type_pp.ml:	latex_type.pp
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'PP_to_ML false `latex_type` ``;;'\
	        'quit();;' | ${Hol}

latex_type_pp_ml.o:	latex_type_pp.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'loadf `filters`;;'\
		'loadf `hol_trees`;;'\
		'loadf `precedence`;;'\
		'compilet `latex_type_pp`;;'\
		'quit();;' | ${Hol}

latex_term_pp.ml:	latex_term.pp
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'PP_to_ML false `latex_term` ``;;'\
	        'quit();;' | ${Hol}

latex_term_pp_ml.o:	latex_term_pp.ml latex_type_pp_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'loadf `filters`;;'\
		'loadf `hol_trees`;;'\
		'loadf `precedence`;;'\
		'loadf `latex_type_pp`;;'\
		'compilet `latex_term_pp`;;'\
		'quit();;' | ${Hol}

latex_thm_pp.ml:	latex_thm.pp
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'PP_to_ML false `latex_thm` ``;;'\
	        'quit();;' | ${Hol}
latex_thm_pp_ml.o:	latex_thm_pp.ml latex_term_pp_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'loadf `filters`;;'\
		'loadf `hol_trees`;;'\
		'loadf `precedence`;;'\
		'loadf `latex_type_pp`;;'\
		'loadf `latex_term_pp`;;'\
		'compilet `latex_thm_pp`;;'\
		'quit();;' | ${Hol}

latex_sets_pp.ml:	latex_sets.pp
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'PP_to_ML false `latex_sets` ``;;'\
	        'quit();;' | ${Hol}

latex_sets_pp_ml.o:	latex_sets_pp.ml latex_thm_pp_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'loadf `filters`;;'\
		'loadf `hol_trees`;;'\
		'loadf `precedence`;;'\
		'loadf `latex_type_pp`;;'\
		'loadf `latex_term_pp`;;'\
		'loadf `latex_thm_pp`;;'\
		'compilet `latex_sets_pp`;;'\
		'quit();;' | ${Hol}

filters_ml.o:	filters.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
		'compilet `filters`;;'\
		'quit();;' | ${Hol}

hol_trees_ml.o: hol_trees.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
	     'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
	     'compilet `hol_trees`;;'\
	     'quit();;' | ${Hol} 

precedence_ml.o: hol_trees_ml.o precedence.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
	     'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
	     'loadf `hol_trees`;;'\
	     'compilet `precedence`;;'\
	     'quit();;' | ${Hol} 

formaters_ml.o:	formaters.ml filters_ml.o hol_trees_ml.o precedence_ml.o\
	latex_type_pp_ml.o latex_thm_pp_ml.o latex_term_pp_ml.o\
	latex_sets_pp_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_printer`);;'\
		'loadf(library_pathname() ^ `/prettyp/PP_parser`);;'\
		'loadf `filters`;;'\
		'loadf `hol_trees`;;'\
		'loadf `precedence`;;'\
		'loadf `latex_sets_pp`;;'\
		'loadf `latex_thm_pp`;;'\
		'loadf `latex_term_pp`;;'\
		'loadf `latex_type_pp`;;'\
		'compilet `formaters`;;'\
		'quit();;' | ${Hol}

all:	formaters_ml.o
	@echo "===>Library latex-hol rebuilt"

=== Library/more_arithmetic/Makefile ===
#=================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: more_arithmetic
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o
	@echo "===> library more_arithmetic: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l *.th 
	@echo "===> library more_arithmetic: all object code and theory files deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

more_arithmetic.th: mk_more_arithmetic.ml pre.th sub.th  mult.th odd_even.th min_max.th div_mod.th
	rm -f more_arithmetic.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `mk_more_arithmetic`;;'\
	     'quit();;' | ${Hol} 

ineq.th: ineq.ml
	rm -f ineq.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `ineq`;;'\
	     'quit();;' | ${Hol} 


zero_ineq.th: zero.ml ineq.th
	rm -f zero_ineq.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `zero`;;'\
	     'quit();;' | ${Hol} 

suc.th: suc.ml ineq.th
	rm -f suc.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `suc`;;'\
	     'quit();;' | ${Hol} 


add.th: add.ml suc.th
	rm -f add.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `add`;;'\
	     'quit();;' | ${Hol} 


pre.th: pre.ml ineq.th
	rm -f pre.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `pre`;;'\
	     'quit();;' | ${Hol} 


sub.th: sub.ml add.th zero_ineq.th
	rm -f sub.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `sub`;;'\
	     'quit();;' | ${Hol} 


mult.th: mult.ml ineq.th
	rm -f mult.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `mult`;;'\
	     'quit();;' | ${Hol} 

min_max.th: minmax.ml 
	rm -f min_max.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `minmax`;;'\
	     'quit();;' | ${Hol} 

odd_even.th: odd_even.ml 
	rm -f odd_even.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `odd_even`;;'\
	     'quit();;' | ${Hol} 

div_mod.th: div_mod.ml 
	rm -f div_mod.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `div_mod`;;'\
	     'quit();;' | ${Hol} 

num_convs_ml.o: num_convs.ml more_arithmetic.th more_arithmetic.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `num_convs`;;'\
	     'quit();;' | ${Hol}


num_tac_ml.o: num_tac.ml more_arithmetic.th more_arithmetic.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `num_tac`;;'\
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry
# =====================================================================

all: more_arithmetic.th num_convs_ml.o num_tac_ml.o
	@echo "===> library more_arithmetic rebuilt"

=== Library/numeral/Makefile ===
# =====================================================================
#
#                MAKEFILE FOR THE HOL LIBRARY: numeral
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all       : create theories and compile code
#
#    make clean     : remove only compiled code
#
#    make clobber   : remove both theories and compiled code
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

all: numeral_rules_ml.o

clean:; rm -f numeral_rules_ml.o

clobber: clean; rm -f numeral.th

numeral.th: numeral_theory.ml
	echo 'set_flag(`abort_when_fail`,true);;'	\
	     'loadt `numeral_theory`;;'			\
	     'quit();;' | ${Hol}

numeral_rules_ml.o: numeral_rules.ml numeral.th
	rm -f dummy.th
	echo 'set_flag(`abort_when_fail`,true);;'				\
	     'new_theory `dummy`;;'						\
	     'load_library `reduce`;;'						\
	     'new_parent `numeral`;;'						\
	     'let t = `numeral` in do'						\
	     'map (\s. autoload_theory(`definition`,t,fst s)) (definitions t);' \
	     'map (\s. autoload_theory(`theorem`,t,fst s)) (theorems t);;'	\
	     'compilet `numeral_rules`;;'					\
	     'quit();;' | ${Hol}
	rm -f dummy.th

=== Library/pair/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: pair
#
# $Id: Makefile,v 3.1 1993/12/07 14:42:10 jg Exp $
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : check out the source code,
#                     create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
#    make decimate  : remove theories, compiled code and source code
#                     that isn't different to that in REVISION.
#
#    make destroy   : remove theories, compiled code and source code.
#                     HANDLE WITH CARE
#
#    make source    : check out the source code (see REVISION)
#
# ---------------------------------------------------------------------
# MACROS:
#
#    HOL            : the pathname of the version of hol used
#    SOURCE         : all the source files
#    REVISION       : The rcs revision of the source code to get
# =====================================================================

HOL= ../../hol

SOURCE= all.ml basic.ml both1.ml both2.ml conv.ml exi.ml pair.ml syn.ml

REVISION=

# =====================================================================
# Basic functions.
# =====================================================================

all: pair_ml.o
	@echo "===> library pair built"

source: ${SOURCE}

clean:
	rm -f *.l *.c *.o *.h *.data *.i *.s *.ir
	@echo "===> library pair: all object code deleted"

clobber:
	rm -f *.l *.c *.o *.th *.h *.data *.i *.s *.ir
	@echo "===> library pair: all object code and theory files deleted"

# decimate:
# 	rm -f *.l *.c *.o *.th *.h *.data *.i *.s *.ir
# 	rcsclean -r${REVISION} ${SOURCE}
# 	@echo "===> library pair: all source, object code and theories deleted"
# 
# destroy:
# 	rm -f *.l *.c *.o *.th *.h *.data *.i *.s *.ir
# 	rm -f ${SOURCE}
# 	@echo "===> library pair: all source, object code and theories deleted"

.FAILED:
	@echo "===> library pair build failed"

.DEFAULT:
	co -r${REVISION} $@

# =====================================================================
# Entries for individual files.
# =====================================================================

syn_ml.o: syn.ml
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'compilet `syn`;;'				\
        'quit();;' | ${HOL}

basic_ml.o: basic.ml syn_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `syn`;;'					\
        'compilet `basic`;;'				\
        'quit();;' | ${HOL}

both1_ml.o: both1.ml syn_ml.o basic_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `syn`;;'					\
        'loadf `basic`;;'				\
        'compilet `both1`;;'				\
        'quit();;' | ${HOL}

all_ml.o: all.ml syn_ml.o basic_ml.o both1_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `syn`;;'					\
        'loadf `basic`;;'				\
        'loadf `both1`;;'				\
        'compilet `all`;;'				\
        'quit();;' | ${HOL}

exi_ml.o: exi.ml syn_ml.o basic_ml.o both1_ml.o all_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `syn`;;'					\
        'loadf `basic`;;'				\
        'loadf `both1`;;'				\
        'loadf `all`;;'					\
        'compilet `exi`;;'				\
        'quit();;' | ${HOL}

both2_ml.o: both2.ml syn_ml.o basic_ml.o both1_ml.o all_ml.o exi_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `syn`;;'					\
        'loadf `basic`;;'				\
        'loadf `both1`;;'				\
        'loadf `all`;;'					\
        'loadf `exi`;;'					\
        'compilet `both2`;;'				\
        'quit();;' | ${HOL}

conv_ml.o: conv.ml syn_ml.o basic_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `syn`;;'					\
        'loadf `basic`;;'				\
        'compilet `conv`;;'				\
        'quit();;' | ${HOL}

pair_ml.o: pair.ml syn_ml.o basic_ml.o both1_ml.o all_ml.o exi_ml.o	\
		both2_ml.o conv_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'compilet `pair`;;'				\
        'quit();;' | ${HOL}

=== Library/parser/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: parser
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol         : the pathname of the version of hol used
#
#    Obj         : the default filename extension for compiled lisp files,
#		   for franz it is o, for common lisp it depends on the 
#		   implementation
# =====================================================================

Hol=../../hol
Obj=o

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o *_ml.l *.$(Obj)
	@echo "===> library parser: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l *.$(Obj)
	@echo "===> library parser: all object code deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

general_ml.o: general.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `general`;;'\
	     'quit();;' | ${Hol}

parser_ml.o: parser.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `parser`;;' \
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry
# =====================================================================

all: general_ml.o parser_ml.o
	@echo "===> library parser rebuilt"

=== Library/prettyp/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: prettyp
#
# =====================================================================

# =====================================================================
#
# MAIN ENTRIES:
#
# make all	    : compile code
#
# make clean	    : remove compiled code
#	
# make clobber	    : remove compiled code and files generated by
#                     the pretty-printer
#	
# =====================================================================

# =====================================================================
# MACROS:
#
# Hol	    : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

clean:
	rm -f PP_printer/*_ml.o PP_printer/*_ml.l
	rm -f PP_parser/*_ml.o PP_parser/*_ml.l
	rm -f PP_hol/*_ml.o PP_hol/*_ml.l
	@echo "===> library prettyp: all object code deleted"

clobber:
	rm -f PP_printer/*_ml.o PP_printer/*_ml.l
	rm -f PP_parser/*_ml.o PP_parser/*_ml.l PP_parser/*_pp.ml
	rm -f PP_hol/*_ml.o PP_hol/*_ml.l PP_hol/*_pp.ml
	@echo "===> library prettyp: all object code and _pp.ml files deleted"

PP_printer/extents_ml.o: PP_printer/extents.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `PP_printer/extents`;;'\
	     'quit();;' | ${Hol} 

PP_printer/strings_ml.o: PP_printer/extents_ml.o PP_printer/strings.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'compilet `PP_printer/strings`;;'\
	     'quit();;' | ${Hol} 

PP_printer/ptree_ml.o: PP_printer/strings_ml.o PP_printer/ptree.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'compilet `PP_printer/ptree`;;'\
	     'quit();;' | ${Hol} 

PP_printer/treematch_ml.o: PP_printer/ptree_ml.o PP_printer/treematch.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'loadf `PP_printer/ptree`;;'\
	     'compilet `PP_printer/treematch`;;'\
	     'quit();;' | ${Hol} 

PP_printer/boxes_ml.o: PP_printer/treematch_ml.o PP_printer/boxes.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'loadf `PP_printer/ptree`;;'\
	     'loadf `PP_printer/treematch`;;'\
	     'compilet `PP_printer/boxes`;;'\
	     'quit();;' | ${Hol} 

PP_printer/treetobox_ml.o: PP_printer/boxes_ml.o PP_printer/treetobox.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'loadf `PP_printer/ptree`;;'\
	     'loadf `PP_printer/treematch`;;'\
	     'loadf `PP_printer/boxes`;;'\
	     'compilet `PP_printer/treetobox`;;'\
	     'quit();;' | ${Hol} 

PP_printer/boxtostring_ml.o: PP_printer/treetobox_ml.o\
	                     PP_printer/boxtostring.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'loadf `PP_printer/ptree`;;'\
	     'loadf `PP_printer/treematch`;;'\
	     'loadf `PP_printer/boxes`;;'\
	     'loadf `PP_printer/treetobox`;;'\
	     'compilet `PP_printer/boxtostring`;;'\
	     'quit();;' | ${Hol} 

PP_printer/print_ml.o: PP_printer/boxtostring_ml.o PP_printer/print.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'loadf `PP_printer/ptree`;;'\
	     'loadf `PP_printer/treematch`;;'\
	     'loadf `PP_printer/boxes`;;'\
	     'loadf `PP_printer/treetobox`;;'\
	     'loadf `PP_printer/boxtostring`;;'\
	     'compilet `PP_printer/print`;;'\
	     'quit();;' | ${Hol} 

PP_printer/utils_ml.o: PP_printer/print_ml.o PP_printer/utils.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/extents`;;'\
	     'loadf `PP_printer/strings`;;'\
	     'loadf `PP_printer/ptree`;;'\
	     'loadf `PP_printer/treematch`;;'\
	     'loadf `PP_printer/boxes`;;'\
	     'loadf `PP_printer/treetobox`;;'\
	     'loadf `PP_printer/boxtostring`;;'\
	     'loadf `PP_printer/print`;;'\
	     'compilet `PP_printer/utils`;;'\
	     'quit();;' | ${Hol} 

PP_printer: PP_printer/utils_ml.o PP_printer/PP_printer.ml

PP_parser/pp_lang1_pp.ml: PP_printer/extents.ml\
	                  PP_printer/strings.ml\
	                  PP_printer/ptree.ml\
	                  PP_printer/treematch.ml\
	                  PP_printer/boxes.ml\
	                  PP_printer/treetobox.ml\
	                  PP_printer/boxtostring.ml\
	                  PP_printer/print.ml\
	                  PP_printer/utils.ml\
	                  PP_printer/PP_printer.ml\
	                  PP_parser/lex.ml\
	                  PP_parser/syntax.ml\
	                  PP_parser/convert.ml\
	                  PP_parser/generate.ml\
	                  PP_parser/PP_to_ML.ml\
	                  PP_parser/PP_parser.ml\
	                  PP_parser/pp_lang1.pp\
	                  PP_parser/pp_lang2.pp
	(cd PP_parser; cp pp_lang1.build pp_lang1_pp.ml)
	(cd PP_parser; cp pp_lang2.build pp_lang2_pp.ml)
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'compilet `PP_parser/pp_lang1_pp`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'compilet `PP_parser/pp_lang2_pp`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'compilet `PP_parser/lex`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'compilet `PP_parser/syntax`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'compilet `PP_parser/convert`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'loadf `PP_parser/convert`;;'\
	     'compilet `PP_parser/generate`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'loadf `PP_parser/convert`;;'\
	     'loadf `PP_parser/generate`;;'\
	     'compilet `PP_parser/PP_to_ML`;;'\
	     'quit();;' | ${Hol} 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'loadf `PP_parser/convert`;;'\
	     'loadf `PP_parser/generate`;;'\
	     'loadf `PP_parser/PP_to_ML`;;'\
	     'PP_to_ML false `PP_parser/pp_lang1` ``;;'\
	     'PP_to_ML false `PP_parser/pp_lang2` ``;;'\
	     'quit();;' | ${Hol} 

PP_parser/pp_lang2_pp.ml: PP_parser/pp_lang1_pp.ml

PP_parser/pp_lang1_pp_ml.o: PP_printer PP_parser/pp_lang1_pp.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'compilet `PP_parser/pp_lang1_pp`;;'\
	     'quit();;' | ${Hol} 

PP_parser/pp_lang2_pp_ml.o: PP_parser/pp_lang1_pp_ml.o PP_parser/pp_lang2_pp.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'compilet `PP_parser/pp_lang2_pp`;;'\
	     'quit();;' | ${Hol} 

PP_parser/lex_ml.o: PP_parser/pp_lang2_pp_ml.o PP_parser/lex.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'compilet `PP_parser/lex`;;'\
	     'quit();;' | ${Hol} 

PP_parser/syntax_ml.o: PP_parser/lex_ml.o PP_parser/syntax.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'compilet `PP_parser/syntax`;;'\
	     'quit();;' | ${Hol} 

PP_parser/convert_ml.o: PP_parser/syntax_ml.o PP_parser/convert.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'compilet `PP_parser/convert`;;'\
	     'quit();;' | ${Hol} 

PP_parser/generate_ml.o: PP_parser/convert_ml.o PP_parser/generate.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'loadf `PP_parser/convert`;;'\
	     'compilet `PP_parser/generate`;;'\
	     'quit();;' | ${Hol} 

PP_parser/PP_to_ML_ml.o: PP_parser/generate_ml.o PP_parser/PP_to_ML.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/pp_lang1_pp`;;'\
	     'loadf `PP_parser/pp_lang2_pp`;;'\
	     'loadf `PP_parser/lex`;;'\
	     'loadf `PP_parser/syntax`;;'\
	     'loadf `PP_parser/convert`;;'\
	     'loadf `PP_parser/generate`;;'\
	     'compilet `PP_parser/PP_to_ML`;;'\
	     'quit();;' | ${Hol} 

PP_parser: PP_parser/PP_to_ML_ml.o PP_parser/PP_parser.ml

PP_hol/hol_trees_ml.o: PP_parser PP_hol/hol_trees.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/PP_parser`;;'\
	     'compilet `PP_hol/hol_trees`;;'\
	     'quit();;' | ${Hol} 

PP_hol/precedence_ml.o: PP_hol/hol_trees_ml.o PP_hol/precedence.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/PP_parser`;;'\
	     'loadf `PP_hol/hol_trees`;;'\
	     'compilet `PP_hol/precedence`;;'\
	     'quit();;' | ${Hol} 

PP_hol/hol_type_pp.ml: PP_printer/extents.ml\
	               PP_printer/strings.ml\
	               PP_printer/ptree.ml\
	               PP_printer/treematch.ml\
	               PP_printer/boxes.ml\
	               PP_printer/treetobox.ml\
	               PP_printer/boxtostring.ml\
	               PP_printer/print.ml\
	               PP_printer/utils.ml\
	               PP_printer/PP_printer.ml\
	               PP_parser/lex.ml\
	               PP_parser/syntax.ml\
	               PP_parser/convert.ml\
	               PP_parser/generate.ml\
	               PP_parser/PP_to_ML.ml\
	               PP_parser/PP_parser.ml\
	               PP_parser/pp_lang1.pp\
	               PP_parser/pp_lang2.pp\
	               PP_hol/hol_type.pp
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/PP_parser`;;'\
	     'PP_to_ML false `PP_hol/hol_type` ``;;'\
	     'quit();;' | ${Hol} 

PP_hol/hol_type_pp_ml.o: PP_hol/precedence_ml.o PP_hol/hol_type_pp.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `PP_printer/PP_printer`;;'\
	     'loadf `PP_parser/PP_parser`;;'\
	     'loadf `PP_hol/hol_trees`;;'\
	     'loadf `PP_hol/precedence`;;'\
	     'compilet `PP_hol/hol_type_pp`;;'\
	     'quit();;' | ${Hol} 

PP_hol/hol_term_pp.ml: PP_printer/extents.ml\
	               PP_printer/strings.ml\
	               PP_printer/ptree.ml\
	               PP_printer/treematch.ml\
	               PP_printer/boxes.ml\
	               PP_printer/treetobox.ml\

=== Library/reals/Makefile ===
# =====================================================================
#
#                MAKEFILE FOR THE HOL LIBRARY: reals
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all       : create theories and compile code[*]
#
#    make clean     : remove only compiled code[*]
#
#    make clobber   : remove both theories and compiled code[*]
#
# [*] In fact this library contains no compiled code
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

all:; cd theories; make all

clean:; cd theories; make clean

clobber:; cd theories; make clobber

=== debian/changelog ===
hol88 (2.02.19940316dfsg-8) unstable; urgency=medium

  * build-dep latest gcl, select CLtL1 image

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 09:59:29 -0400

hol88 (2.02.19940316dfsg-7) unstable; urgency=medium

  * packaging cleanups
  * Bug fix: "ftbfs with GCC-15", thanks to Matthias Klose (Closes:
    #1096815).

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 08:08:20 -0400

hol88 (2.02.19940316dfsg-6) unstable; urgency=high

  * build-dep gcl27

 -- Camm Maguire <camm@debian.org>  Fri, 25 Apr 2025 13:46:25 -0400

hol88 (2.02.19940316dfsg-5) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 08 Jan 2023 17:11:46 -0500

hol88 (2.02.19940316dfsg-4) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 25 Dec 2022 17:55:57 -0500

hol88 (2.02.19940316dfsg-3) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 14:46:36 -0500

hol88 (2.02.19940316dfsg-2) unstable; urgency=medium

  * build-dep latest gcl
  * prune build-deps

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 12:57:57 -0500

hol88 (2.02.19940316dfsg-1) unstable; urgency=medium

  * Repack without NOWEB
  * Bug fix: "license issues", thanks to Bastian Germann (Closes:
    #1021314).
  * Accept NMU

 -- Camm Maguire <camm@debian.org>  Tue, 01 Nov 2022 21:20:09 -0400

hol88 (2.02.19940316-35.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Tue, 05 Jan 2021 12:37:31 +0100

hol88 (2.02.19940316-35) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 29 Aug 2017 22:52:36 +0000

hol88 (2.02.19940316-34) unstable; urgency=high

  * build-dep latest gcl
  * Bug fix: "FTBFS: Error: ERROR &quot;The default dispatch macro
    signalled an error.&quot;", thanks to Lucas Nussbaum (Closes:
    #871364).

 -- Camm Maguire <camm@debian.org>  Thu, 24 Aug 2017 10:59:05 +0000

hol88 (2.02.19940316-33) unstable; urgency=high

  * Bug fix: "hol88-library is an empty package on arm64, hppa, and m68k",
    thanks to Helmut Grohne (Closes: #857296).
  * build-dep on latest gcl
  * deprecated dh -s to -a in debian/rules
  * lintian override for hol88-help *.doc
  * temp files in clean target

 -- Camm Maguire <camm@debian.org>  Thu, 11 May 2017 19:24:09 +0000

hol88 (2.02.19940316-32) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 13 Oct 2016 19:34:07 +0000

hol88 (2.02.19940316-31) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 07 Oct 2015 21:39:55 +0000

hol88 (2.02.19940316-30) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 01 Oct 2015 22:16:36 +0000

hol88 (2.02.19940316-29) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 30 Sep 2015 22:03:50 +0000

hol88 (2.02.19940316-28) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 24 Oct 2014 10:35:41 -0400

hol88 (2.02.19940316-27) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 07 Sep 2014 22:37:23 -0400

hol88 (2.02.19940316-26) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 21 Aug 2014 18:47:39 +0000

hol88 (2.02.19940316-25) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 19 Aug 2014 19:21:14 +0000

hol88 (2.02.19940316-24) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Mon, 11 Aug 2014 16:13:22 +0000

hol88 (2.02.19940316-23) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 24 Jul 2014 21:47:33 +0000

hol88 (2.02.19940316-22) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Mon, 21 Jul 2014 14:58:54 +0000

hol88 (2.02.19940316-21) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 16 Jul 2014 21:12:45 +0000

hol88 (2.02.19940316-20) unstable; urgency=low

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 02 Jul 2014 20:34:24 +0000

=== debian/control ===
Source: hol88
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: debhelper-compat (= 13), gcl27 (>= 2.7.1-6), texlive-latex-base
Standards-Version: 4.7.2

Package: hol88
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Higher Order Logic, system image
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-source
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Higher Order Logic, source files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-help
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Higher Order Logic, online help files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-library
Architecture: any
Depends: ${misc:Depends}
Description: Higher Order Logic, binary library modules
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-library-source
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Higher Order Logic, library source files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-library-help
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Higher Order Logic, library online help files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-contrib-source
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Higher Order Logic, user contributed source
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-contrib-help
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Higher Order Logic, user contributed online help files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation for hol88
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=hol88
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)

configure: configure-stamp
configure-stamp:
	dh_testdir
#	cat debian/dash.p | patch -p1
	touch configure-stamp


build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 

	echo '(shadow "LIST")' \
	     '(defmacro list (&rest r &aux (l (length r)))' \
		 '(let ((x (nthcdr (1- call-arguments-limit) r)))' \
		    '(if x `(nconc (cl::list ,@(ldiff r x)) (list ,@x)) `(cl::list ,@r))))' \
             '(deftype list nil (quote cl::list))' \
	     '(use-package :cltl1-compat)' \
	     '(si::save-system "gcl")' | GCL_ANSI="no" gcl27 # FIXME list calls > call-arguments-limit
#	echo '(si::save-system "gcl")' | gcl
	PATH=$$(pwd):$$PATH $(MAKE) all
	find -name "raw_*_map" -exec rm {} \;
	for i in $$(find -maxdepth 1 -name "*hol*"); do \
		printf 'install `'/usr/share/$(PD)'`;;\nlisp `(ml-save "foo")`;;\n' | ./$$i &&\
		mv foo $$i; done
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp 


	for i in Manual/Tutorial/ack.tex Manual/Reference/ack.tex Manual/Description/ack.tex; do\
		ln -snf ../Latex/ack.tex $$i ; done
	for i in $$(find Library -name index.tex) Library/pred_sets/Manual/theorems.tex Library/record_proof/Manual/record_proof.ind ; do\
		[ -e $$i.sve ] || cp $$i $$i.sve ; done
	$(MAKE) -C Manual all
	touch $@

INSTALLA:=$(addprefix debian/,$(addsuffix .install,\
	hol88 hol88-library))
INSTALLI:=$(addprefix debian/,$(addsuffix .install,\
	hol88-source hol88-help hol88-library-source\
	hol88-library-help hol88-contrib-source hol88-contrib-help hol88-doc))
LINKS:=$(addprefix debian/,$(addsuffix .links,hol88 hol88-library))

clean:
	dh_testdir
	dh_testroot

#	! [ -e configure-stamp ] || cat debian/dash.p | patch -p1 -R
	rm -f build-arch-stamp build-indep-stamp configure-stamp

	[ ! -f Makefile ] || $(MAKE) clean
	[ ! -f Makefile ] || $(MAKE) clobber
	for i in $$(find Library -name index.tex) Library/pred_sets/Manual/theorems.tex Library/record_proof/Manual/record_proof.ind ; do\
		[ -e $$i.sve ] || cp $$i $$i.sve ; done
	[ ! -f Makefile ] || $(MAKE) -C Manual clean

	[ ! -f Makefile ] || for i in $$(find Library -name Manual); do $(MAKE) -C $$i clean ; done
	find -name X.tex -exec rm -rf {} \;

	dh_clean -X./ml/site.ml.orig -X./contrib/tooltool/Makefile.orig \
		 -X./contrib/tooltool/events.c.orig -X./contrib/tooltool/func_fix.c.orig \
	         -X./contrib/tooltool/lex.c.orig -X./contrib/tooltool/parse.y.orig \
		 -X./contrib/tooltool/patchlevel.h.orig -X./contrib/tooltool/windows.c.orig \
		 -X./contrib/Xhelp/hol_apro.orig -X./contrib/Xhelp/hol_ref.orig \
		 -X./contrib/Xhelp/xholhelp.h.orig -X./contrib/Xhelp/hol_thm.orig

	for i in $$(find Library -name "*.sve") ; do mv $$i $$(echo $$i | sed "s,\.sve,,1"); done

	rm -f $(INSTALLA) $(INSTALLI) $(LINKS) debian/hol88.sh
	find -name "*.dvi" -exec rm {} \;
	rm -f Manual/Tutorial/ack.tex Manual/Reference/ack.tex Manual/Description/ack.tex
	rm -f Manual/Covers/titlepages.ps Manual/Covers/endpages.ps
	rm -f bm.l foo* gcl ./lisp/f-ol-syntax.data
	cp debian/site_ml_orig ml/site.ml.orig
	rm -f   Library/finite_sets/Manual/entries.tex \
		Library/finite_sets/Manual/theorems.tex \
		Library/more_arithmetic/Manual/theorems.tex \
		Library/numeral/Manual/theorems.tex \
		Library/pred_sets/Manual/entries.tex \
		Library/prettyp/Manual/entries.tex \
		Library/reals/Manual/theorems.tex \
		Library/res_quan/Manual/entries.tex \
		Library/sets/Manual/entries.tex \
		Library/sets/Manual/theorems.tex \
		Library/string/Manual/theorems.tex \
		Library/wellorder/Manual/theorems.tex \
		Library/word/Manual/theorems.tex \
		Manual/Reference/entries.tex \
		Manual/Reference/theorems.tex



debian/hol88.install:: 
	find -maxdepth 1 -name "*hol*" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	echo debian/hol88.sh usr/bin >>$@
debian/hol88-source.install:: 
	find lisp -name "*.l" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find ml -type f -name "*ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find theories -type f -name "*ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find theories -type f -name "*th" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-help.install:: 
	find help -name "*.doc" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/hol88-library.install:: 
	find Library -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-library-source.install:: 
	find Library -name "*.ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-library-help.install:: 
	find Library -name "*.doc" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/hol88-contrib-source.install:: 
	find contrib -name "*.ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find contrib -name "Makefile" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-contrib-help.install:: 
	find contrib -name "*.doc" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/hol88-doc.install:: 
	find Manual -name "*dvi" | grep -v makeindex | grep -v psfig | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/hol88-doc/%s\n",$$1,a);}' >>$@
	find Manual -name "*ps" | grep -v makeindex | grep -v psfig | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/hol88-doc/%s\n",$$1,a);}' >>$@


debian/hol88.links:: 
	find * -maxdepth 0 -name "*hol*" | awk '{printf("/usr/lib/$(PD)/%s usr/share/$(PD)/%s\n",$$1,$$1);}' >>$@
debian/hol88-library.links:: 
	find Library -name "*.o" | awk '{printf("/usr/lib/$(PD)/%s usr/share/$(PD)/%s\n",$$1,$$1);}' >>$@


debian/hol88.sh:
	echo "#!/bin/bash" >$@
	echo >>$@
	echo "exec /usr/lib/$(PD)/hol" >>$@
	chmod 755 $@


install: install-indep install-arch
install-indep: $(INSTALLI)
	dh_testdir
	dh_testroot
	dh_prep -i -X./ml/site.ml.orig -X./contrib/tooltool/Makefile.orig \
		 -X./contrib/tooltool/events.c.orig -X./contrib/tooltool/func_fix.c.orig \
	         -X./contrib/tooltool/lex.c.orig -X./contrib/tooltool/parse.y.orig \
		 -X./contrib/tooltool/patchlevel.h.orig -X./contrib/tooltool/windows.c.orig \
		 -X./contrib/Xhelp/hol_apro.orig -X./contrib/Xhelp/hol_ref.orig \
		 -X./contrib/Xhelp/xholhelp.h.orig -X./contrib/Xhelp/hol_thm.orig

	dh_installdirs -i

	dh_install -i

install-arch: $(INSTALLA) $(LINKS) debian/hol88.sh
	dh_testdir
	dh_testroot
	dh_prep -a -X./ml/site.ml.orig -X./contrib/tooltool/Makefile.orig \
		 -X./contrib/tooltool/events.c.orig -X./contrib/tooltool/func_fix.c.orig \
	         -X./contrib/tooltool/lex.c.orig -X./contrib/tooltool/parse.y.orig \
		 -X./contrib/tooltool/patchlevel.h.orig -X./contrib/tooltool/windows.c.orig \
		 -X./contrib/Xhelp/hol_apro.orig -X./contrib/Xhelp/hol_ref.orig \
		 -X./contrib/Xhelp/xholhelp.h.orig -X./contrib/Xhelp/hol_thm.orig

	dh_installdirs -a

	dh_install -a

	mv debian/hol88/usr/bin/hol88.sh debian/hol88/usr/bin/hol88

binary-common:
	dh_testdir
	dh_testroot
